use strict;
use warnings;
use Test::More;
use lib './t/lib';
use PScm::Test tests => 5;
use FileHandle;

BEGIN { use_ok('PScm') }

eval_ok(<<EOF, '16', 'lambda');
(let ((square
       (lambda (x) (* x x))))
     (square 4))
EOF

eval_ok(<<EOF, '(lambda (x) (* x x))', 'lambda to string');
(let ((square
       (lambda (x) (* x x))))
     square)
EOF

eval_ok(<<EOF, '12', 'closure');
(let ((times3
      (let ((n 3))
           (lambda (x) (* n x)))))
     (times3 4))
EOF

eval_ok(<<EOF, '15', 'higher order functions');
(let ((times3
      (let ((makemultiplier
             (lambda (n)
                     (lambda (x) (* n x)))))
           (makemultiplier 3))))
     (times3 5))
EOF

# vim: ft=perl
